=== modified file 'NEWS'
--- NEWS	2008-06-02 22:50:22 +0000
+++ NEWS	2008-06-03 02:13:34 +0000
@@ -100,6 +100,9 @@
       them.
       (Vincent Ladeuil, #229076)
 
+    * The "Unable to obtain lock" error message now also suggests using
+      ``bzr break-lock`` to fix it.  (Martin Albisetti, #139202)
+
     * Treat an encoding of '' as ascii; this can happen when bzr is run
       under vim on Mac OS X.
       (Neil Martinsen-Burrell)

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2008-04-24 07:22:53 +0000
+++ bzrlib/lockdir.py	2008-05-21 01:38:52 +0000
@@ -506,15 +506,20 @@
                 if deadline_str is None:
                     deadline_str = time.strftime('%H:%M:%S',
                                                  time.localtime(deadline))
+                lock_url = self.transport.abspath(self.path)
                 self._report_function('%s %s\n'
                                       '%s\n' # held by
                                       '%s\n' # locked ... ago
-                                      'Will continue to try until %s\n',
+                                      'Will continue to try until %s, unless '
+                                      'you press Ctrl-C\n'
+                                      'If you\'re sure that it\'s not being '
+                                      'modified, use bzr break-lock %s',
                                       start,
                                       formatted_info[0],
                                       formatted_info[1],
                                       formatted_info[2],
-                                      deadline_str)
+                                      deadline_str,
+                                      lock_url)
 
             if (max_attempts is not None) and (attempt_count >= max_attempts):
                 self._trace("exceeded %d attempts")

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2007-12-17 15:17:28 +0000
+++ bzrlib/tests/test_lockdir.py	2008-05-21 02:13:43 +0000
@@ -190,9 +190,13 @@
             lf1.unlock()
         lock_base = lf2.transport.abspath(lf2.path)
         self.assertEqual(1, len(self._logged_reports))
+        lock_url = lf2.transport.abspath(lf2.path)
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s\n',
+                         'Will continue to try until %s, unless '
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -406,10 +410,13 @@
         # There should be 2 reports, because the lock changed
         lock_base = lf2.transport.abspath(lf2.path)
         self.assertEqual(2, len(self._logged_reports))
-
+        lock_url = lf2.transport.abspath(lf2.path)
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s\n',
+                         'Will continue to try until %s, unless '
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -421,7 +428,10 @@
 
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s\n',
+                         'Will continue to try until %s, unless '
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[1][0])
         args = self._logged_reports[1][1]
         self.assertEqual('Lock owner changed for', args[0])

